--Generovano z django modelu + dole dalsi constrainty apod.:

SET client_min_messages TO warning;

DROP TABLE IF EXISTS "enum_stat_type" CASCADE;
DROP TABLE IF EXISTS "stat" CASCADE;
DROP TABLE IF EXISTS "zone" CASCADE;
DROP TABLE IF EXISTS "enum_rec_type" CASCADE;

BEGIN;
CREATE TABLE "enum_rec_type" (
    "id" serial NOT NULL PRIMARY KEY,
    "rec_type_desc" varchar(256) NOT NULL,
    "stat_type_id" integer NOT NULL,
    "display_nil" smallint NOT NULL,
    "collect_oper" smallint NOT NULL,
    "object_id" integer NULL,
    "position" integer NOT NULL
)
;
CREATE TABLE "enum_stat_type" (
    "id" serial NOT NULL PRIMARY KEY,
    "stat_type_desc" varchar(256) NOT NULL,
    "position" integer NOT NULL,
    "zone_needed" boolean NOT NULL
)
;
ALTER TABLE "enum_rec_type" ADD CONSTRAINT stat_type_id_refs_id_7a027b2a FOREIGN KEY ("stat_type_id") REFERENCES "enum_stat_type" ("id") DEFERRABLE INITIALLY DEFERRED;
CREATE TABLE "stat" (
    "id" serial NOT NULL PRIMARY KEY,
    "year" smallint NOT NULL,
    "month" smallint NOT NULL,
    "day" smallint NOT NULL,
    "value_date" date NULL,
    "rec_type_id" integer NOT NULL REFERENCES "enum_rec_type" ("id") DEFERRABLE INITIALLY DEFERRED,
    "value" integer NOT NULL,
    "zone_id" integer NOT NULL,
    "inserted_date" timestamp with time zone NOT NULL
)
;
CREATE TABLE "zone" (
    "id" serial NOT NULL PRIMARY KEY,
    "name" varchar(256) NOT NULL,
    "position" integer NOT NULL
)
;
ALTER TABLE "stat" ADD CONSTRAINT zone_id_refs_id_4bbd549d FOREIGN KEY ("zone_id") REFERENCES "zone" ("id") DEFERRABLE INITIALLY DEFERRED;
CREATE INDEX "enum_rec_type_stat_type_id" ON "enum_rec_type" ("stat_type_id");
CREATE INDEX "stat_rec_type_id" ON "stat" ("rec_type_id");
CREATE INDEX "stat_zone_id" ON "stat" ("zone_id");
COMMIT;





--MOJE RUCNE NAPSANE:

--Jedinecny index sloupcu (year, month, day, zone_id) nad tabulkou stat;
ALTER TABLE stat ADD CONSTRAINT stat_date_rtype_zone_unique UNIQUE (year, month, day, rec_type_id, zone_id);
--CREATE UNIQUE INDEX stat_date_rtype_zone_unique_index ON stat (year, month, day, rec_type_id, zone_id);
CREATE INDEX stat_value_date_index ON stat (value_date);


--Trigger na nahrazeni insertu updatem, pokud uz dana jedinecna petice (year, month, day, rec_type_id, zone_id) existuje
-- CREATE OR REPLACE FUNCTION stat_update_instead_insert() RETURNS TRIGGER AS $$
-- DECLARE
--   stat_row stat%ROWTYPE;
-- BEGIN

--   SELECT INTO stat_row *
--    FROM stat
--    WHERE year = NEW.year AND month = NEW.month AND day = NEW.day AND rec_type_id = NEW.rec_type_id AND zone_id = NEW.zone_id;

--   IF NOT FOUND THEN
--     --RAISE NOTICE 'Ahoj, jsem v triggeru INSERT';
--     RETURN NEW;
--   ELSE
--     RAISE NOTICE 'Ahoj, jsem v triggeru UPDATE';
--     UPDATE stat SET value = NEW.value WHERE year = NEW.year AND month = NEW.month AND day = NEW.day AND rec_type_id = NEW.rec_type_id AND zone_id = NEW.zone_id;
--     RETURN NULL;
--   END IF;
-- END;
-- $$ LANGUAGE plpgsql;

-- CREATE TRIGGER trig_stat_update_instead_insert BEFORE INSERT
--  ON stat FOR EACH ROW
--  EXECUTE PROCEDURE stat_update_instead_insert();
